OpenNMS API 1.2.9

## org.opennms.netmgt.poller.monitors
Interface ServiceMonitor

All Known Implementing Classes:
  IPv4LatencyMonitor, IPv4Monitor, MockMonitor

public interface ServiceMonitor

This is the interface that must be implemented by each poller plugin in the framework. This well defined interface allows the framework to treat each plugin identically.

When a service monitor plug-in is loaded and initialized, the framework will initialize the monitor by calling the initialize() method. Likewise, when the monitor is unloaded the framework calls the release() method is called. If the plug-in needs to save or read any configuration information after the initialize() call, a reference to the proxy object should be saved at initialization.

NOTE: The plug-in poll() must be thread safe in order to operate. Any synchronized methods or data accessed in the poll() can negatively affect the framework if multiple poller threads are blocked on a critical resource. Synchronization issues should be seriously evaluated to ensure that the plug-in scales well to large deployments.

Author:
  Brian Weaver , OpenNMS

Field Summary
`static int` `SERVICE_AVAILABLE` The constant that defines a service as being in a normal state.
`static int` `SERVICE_STATUS_MASK` The status mask is used to mask off the bits that apply to scheduling information only.
`static int` `SERVICE_UNAVAILABLE` The constant that defines a service that is not working normally and should be scheduled using the downtime models.
`static int` `SERVICE_UNKNOWN` The constant the defines a status is unknown.
`static int` `SERVICE_UNRESPONSIVE` The constant that defines a service that is up but is most likely suffering due to excessive load or latency issues and because of that has not responded within the configured timeout period.
`static int` `SURPRESS_EVENT_MASK` This constants defines the mask that can be bitwise anded with the status return from the poll() method to determine if a status event should be surpressed.

Method Summary
`void` `initialize(NetworkInterface iface)` This method is called whenever a new interface that supports the plug-in service is added to the scheduling system.
`void` `initialize(PollerConfig config, java.util.Map parameters)` This method is called after the framework creates an instance of the plug-in.
`int` `poll(NetworkInterface iface, java.util.Map parameters, Package pkg)` This method is the heart of the plug-in monitor.
`void` `release()` This method is called whenever the plug-in is being unloaded, normally during framework exit.
`void` `release(NetworkInterface iface)` This method is the called whenever an interface is being removed from the scheduler.

Field Detail

### SERVICE_UNKNOWN

    public static final int SERVICE_UNKNOWN

  The constant the defines a status is unknown. Used mostly internally

  See Also:
    Constant Field Values

### SERVICE_AVAILABLE

    public static final int SERVICE_AVAILABLE

  The constant that defines a service as being in a normal state. If this is returned by the poll() method then the framework will re-schedule the service for its next poll using the standard uptime interval

  See Also:
    Constant Field Values

### SERVICE_UNAVAILABLE

    public static final int SERVICE_UNAVAILABLE

  The constant that defines a service that is not working normally and should be scheduled using the downtime models.

  See Also:
    Constant Field Values

### SERVICE_UNRESPONSIVE

    public static final int SERVICE_UNRESPONSIVE

  The constant that defines a service that is up but is most likely suffering due to excessive load or latency issues and because of that has not responded within the configured timeout period.

  See Also:
    Constant Field Values

### SERVICE_STATUS_MASK

    public static final int SERVICE_STATUS_MASK

  The status mask is used to mask off the bits that apply to scheduling information only. The other bits of the status return information are used to encode special processing instructions to the poller framework.

  See Also:
    Constant Field Values

### SURPRESS_EVENT_MASK

    public static final int SURPRESS_EVENT_MASK

  This constants defines the mask that can be bitwise anded with the status return from the poll() method to determine if a status event should be surpressed. By default the framework will generate an event when the status transitions from up to down or vice versa. If the mask bit is set then the framework should not generate a transitional event.

  See Also:
    Constant Field Values

Method Detail

### initialize

    public void initialize(PollerConfig config,
                           java.util.Map parameters)

  This method is called after the framework creates an instance of the plug-in. The framework passes the object a proxy object that can be used to retreive configuration information specific to the plug-in. Additionally, any parameters for the plug-in from the package definition are passed using the parameters element.

  If there is a critical error, like missing service libraries, the the montior may throw a ServiceMonitorException. If the plug-in throws an exception then the plug-in will be disabled in the framework.

  Parameters:
    `parameters` - Not currently used
  Throws:
    `java.lang.RuntimeException` - Thrown if an unrecoverable error occurs that prevents the plug-in from functioning.

### release

    public void release()

  This method is called whenever the plug-in is being unloaded, normally during framework exit. During this time the framework may release any resource and save any state information using the proxy object from the initialization routine.

  Even if the plug-in throws a monitor exception, it will not prevent the plug-in from being unloaded. The plug-in should not return until all of its state information is saved. Once the plug-in returns from this call its configuration proxy object is considered invalid.

  Throws:
    `java.lang.RuntimeException` - Thrown if an error occurs during deallocation.

### initialize

    public void initialize(NetworkInterface iface)

  This method is called whenever a new interface that supports the plug-in service is added to the scheduling system. The plug-in has the option to load and/or associate configuration information with the interface before the framework begins scheduling the new device.

  Should a monitor exception be thrown during an initialization call then the framework will log an error and discard the interface from scheduling.

  Parameters:
    `iface` - The network interface to be added to the scheduler.
  Throws:
    `java.lang.RuntimeException` - Thrown if an unrecoverable error occurs that prevents the interface from being monitored.
    `NetworkInterfaceNotSupportedException` - Thrown if the passed interface is invalid for this monitor.

### release

    public void release(NetworkInterface iface)

  This method is the called whenever an interface is being removed from the scheduler. For example, if a service is determined as being no longer supported then this method will be invoked to cleanup any information associated with this device. This gives the implementor of the interface the ability to serialize any data prior to the interface being discarded.

  If an exception is thrown during the release the exception will be logged, but the interface will still be discarded for garbage collection.

  Parameters:
    `iface` - The network interface that was being monitored.
  Throws:
    `java.lang.RuntimeException` - Thrown if an unrecoverable error occurs that prevents the interface from being monitored.

### poll

    public int poll(NetworkInterface iface,
                    java.util.Map parameters,
                    Package pkg)

  This method is the heart of the plug-in monitor. Each time an interface requires a check to be performed as defined by the scheduler the poll method is invoked. The poll is passed the interface to check

  By default when the status transition from up to down or vice versa the framework will generate an event. Additionally, if the polling interval changes due to an extended unavailbility, the framework will generate an additional down event. The plug-in can surpress the generation of the default events by setting the surpress event bit in the returned integer.

  Parameters:
    `iface` - The network interface to test the service on.
    `parameters` - The package parameters (timeout, retry, etc...) to be used for this poll.
  Returns:
    The availibility of the interface and if a transition event should be surpressed.
  Throws:
    `java.lang.RuntimeException` - Thrown if an unrecoverable error occurs that prevents the interface from being monitored.
  See Also:
    `SURPRESS_EVENT_MASK`, `SERVICE_AVAILABLE`, `SERVICE_UNAVAILABLE`

OpenNMS API 1.2.9

Generated by ranger on May 19 2007 2335.